float4x4 mTransform;			// ϊs

float FogParameter[2];			// tHOFp[^[
float4 FogTransform;			// tHOFylZop

struct VS_INPUT
{
    float4 Position		: POSITION;		// _ʒu
    float3 Normal		: NORMAL;		// _@
    float4 Color		: COLOR0;		// _F
    float2 TexUV		: TEXCOORD0;	// tu
};

struct VS_OUTPUT
{
    float4 Position		: POSITION;		// ʒu
    float4 Color		: COLOR0;		// F
	float2 TexUV		: TEXCOORD0;	// tu
	float Fog			: FOG;			// tHOW
};

VS_OUTPUT SampleVertexShader( const VS_INPUT Input )
{
	// o̓f[^
    VS_OUTPUT Output = (VS_OUTPUT)0;

	// Wϊ
    Output.Position = mul( Input.Position, mTransform );

	// eNX`tu
	Output.TexUV.xy = Input.TexUV.xy;

	// _F
	Output.Color = Input.Color;

	// tHȌ
	float FogZ = mul( Input.Position, FogTransform );
	Output.Fog = FogZ * FogParameter[0] + FogParameter[1];

    return Output;
}

technique SampleShader
{
	//--------------------------------- pXO
	pass P0
	{
		// yobt@͂nm
		ZEnable = TRUE;
		ZWriteEnable = TRUE;

        // JOKp
        CullMode = CCW;

		// eNX`[h
		ColorArg1[0] = TEXTURE;
		ColorArg2[0] = CURRENT;
		ColorOp[0] = MODULATE;

        // eNX`JԂ[h
        AddressU[0] = WRAP;
        AddressV[0] = WRAP;

		// oCjAtB^OKp
        MinFilter[0] = LINEAR;
        MagFilter[0] = LINEAR;
        MipFilter[0] = LINEAR;

		// tHOnm
		FogEnable = TRUE;

		// _VF[_[
		VertexShader = compile vs_1_1 SampleVertexShader();
	}
}

