float4x4 mTransform;			// ϊs

bool LightIsUse[4];				// CgFgpLtO
bool LightIsDirectional[4];		// CgFstO
float LightAttenuation[4];		// CgFX|bgCg
float4 LightColor[4];			// CgFF
float4 LightParameter[4];		// CgForʒu

float4 MaterialDiffuse;			// }eAFfBt[Y
float4 MaterialAmbient;			// }eAFArGg


struct VS_INPUT
{
    float4 Position		: POSITION;		// _ʒu
    float3 Normal		: NORMAL;		// _@
    float4 Diffuse		: COLOR0;		// _F
    float2 TexUV		: TEXCOORD0;	// tu
};

struct VS_OUTPUT
{
    float4 Position		: POSITION;		// ʒu
    float4 Color		: COLOR0;		// F
	float2 TexUV		: TEXCOORD0;	// tu
};

float4 ComputeLight( int no, float3 norm, float4 pos )
{
	float Pow, vLen;
	float3 vLight;
	float4 Color = { 0, 0, 0, 0 };

	if ( LightIsUse[no] )
	{
		// fBNViCg
		Pow = -dot( LightParameter[no], norm );		// Cg
		Color = max( 0, LightColor[no] * Pow );		// Cg̐FZo
	}

	return Color;
}

VS_OUTPUT SampleVertexShader( const VS_INPUT Input )
{				
	// o̓f[^
    VS_OUTPUT Output = (VS_OUTPUT)0;

	// Wϊ
    Output.Position = mul( Input.Position, mTransform );

	// eNX`tu
	Output.TexUV.xy = Input.TexUV.xy;

	// CeBO
	float4 Color = { 0, 0, 0, 0 };
	Color += ComputeLight( 0, Input.Normal, Input.Position );
	Color += ComputeLight( 1, Input.Normal, Input.Position );
	Color += ComputeLight( 2, Input.Normal, Input.Position );
	Color += ComputeLight( 3, Input.Normal, Input.Position );

	// }eȀl
	Output.Color = min( 1, (Color * MaterialDiffuse) + MaterialAmbient );
	Output.Color.a = MaterialDiffuse.a;

    return Output;
}

technique SampleShader
{
	//--------------------------------- pXO
	pass P0
	{
		// yobt@͂nm
		ZEnable = TRUE;
		ZWriteEnable = TRUE;

        // JOKp
        CullMode = CCW;

		// eNX`[h
		ColorArg1[0] = TEXTURE;
		ColorArg2[0] = CURRENT;
		ColorOp[0] = MODULATE;

        // eNX`JԂ[h
        AddressU[0] = WRAP;
        AddressV[0] = WRAP;

		// oCjAtB^OKp
        MinFilter[0] = LINEAR;
        MagFilter[0] = LINEAR;
        MipFilter[0] = LINEAR;

		// _VF[_[
		VertexShader = compile vs_2_0 SampleVertexShader();
	}
}

