float4x4 mTransform;			// ϊs

float4 MaterialDiffuse;			// }eAFfBt[Y
float SlideTextureU;			// eNX`tXChl
float SlideTextureV;			// eNX`uXChl

struct VS_INPUT
{
    float4 Position		: POSITION;		// _ʒu
    float3 Normal		: NORMAL;		// _@
    float4 Diffuse		: COLOR0;		// _F
    float2 TexUV		: TEXCOORD0;	// tu
};

struct VS_OUTPUT
{
    float4 Position		: POSITION;		// ʒu
    float4 Diffuse		: COLOR0;		// _F
	float2 TexUV		: TEXCOORD0;	// tu
};

VS_OUTPUT SampleVertexShader( const VS_INPUT Input )
{				
	// o̓f[^
    VS_OUTPUT Output = (VS_OUTPUT)0;

	// Wϊ
    Output.Position = mul( Input.Position, mTransform );

	// eNX`tu
	Output.TexUV.x = Input.TexUV.x + SlideTextureU;
	Output.TexUV.y = Input.TexUV.y + SlideTextureV;

	// F
	Output.Diffuse = MaterialDiffuse;

    return Output;
}

technique SampleShader
{
	//--------------------------------- pXO
	pass P0
	{
		// yobt@͂nm
		ZEnable = TRUE;
		ZWriteEnable = TRUE;

        // JOKp
        CullMode = CCW;

		// eNX`[h
		ColorArg1[0] = TEXTURE;
		ColorArg2[0] = CURRENT;
		ColorOp[0] = MODULATE;

        // eNX`JԂ[h
        AddressU[0] = WRAP;
        AddressV[0] = WRAP;

		// oCjAtB^OKp
        MinFilter[0] = LINEAR;
        MagFilter[0] = LINEAR;
        MipFilter[0] = LINEAR;

		// _VF[_[
		VertexShader = compile vs_2_0 SampleVertexShader();
	}
}

